NestingKind (Java SE 26 & JDK 26)
Description: declaration: module: java.compiler, package: javax.lang.model.element, enum: NestingKind
Keywords: javax.lang.model.element.NestingKind class

# Enum Class NestingKind

java.lang.Object
java.lang.Enum<NestingKind>
javax.lang.model.element.NestingKind

All Implemented Interfaces:
  `Serializable, Comparable<NestingKind>, Constable`

public enum NestingKind extends Enum<NestingKind>
The nesting kind of a type element. Type elements come in four varieties: top-level, member, local, and anonymous. Nesting kind is a non-standard term used here to denote this classification.

Note that it is possible additional nesting kinds will be added in future versions of the platform.

Example: The classes below are annotated with their nesting kind.

>     import java.lang.annotation.*;
>     import static java.lang.annotation.RetentionPolicy.*;
>     import javax.lang.model.element.*;
>     import static javax.lang.model.element.NestingKind.*;

>     @Nesting(TOP_LEVEL)
>     public class NestingExamples {
>         @Nesting(MEMBER)
>         static class MemberClass1{}

>         @Nesting(MEMBER)
>         class MemberClass2{}

>         public static void main(String... argv) {
>             @Nesting(LOCAL)
>             class LocalClass{};

>             Class<?>[] classes = {
>                 NestingExamples.class,
>                 MemberClass1.class,
>                 MemberClass2.class,
>                 LocalClass.class
>             };

>             for(Class<?> clazz : classes) {
>                 System.out.format("%s is %s%n",
>                                   clazz.getName(),
>                                   clazz.getAnnotation(Nesting.class).value());
>             }
>         }
>     }

>     @Retention(RUNTIME)
>     @interface Nesting {
>         NestingKind value();
>     }

Since:
  1.6

- ## Nested Class Summary

  ### Nested classes/interfaces declared in class Enum

  `Enum.EnumDesc<E>`
  Modifier and Type
  Class
  Description
  `static final class`
  `Enum.EnumDesc<E extends Enum<E>>`
  A nominal descriptor for an `enum` constant.

- ## Enum Constant Summary

  Enum Constants
  Enum Constant
  Description
  `ANONYMOUS`
  A class without a name.
  `LOCAL`
  A named class or interface declared within a construct other than a class or interface.
  `MEMBER`
  A class or interface that is a named member of another class or interface.
  `TOP_LEVEL`
  A top-level class or interface, not contained within another class or interface.

- ## Method Summary

  Modifier and Type
  Method
  Description
  `boolean`
  `isNested()`
  Does this constant correspond to a nested type element?
  `static NestingKind`
  `valueOf(String name)`
  Returns the enum constant of this class with the specified name.
  `static NestingKind[]`
  `values()`
  Returns an array containing the constants of this enum class, in the order they are declared.

  ### Methods declared in class Enum

  `clone, compareTo, describeConstable, equals, finalize, getDeclaringClass, hashCode, name, ordinal, toString, valueOf`
  Modifier and Type
  Method
  Description
  `protected final Object`
  `clone()`
  Throws CloneNotSupportedException.
  `final int`
  `compareTo(NestingKind o)`
  Compares this enum with the specified object for order.
  `final Optional<Enum.EnumDesc<NestingKind>>`
  `describeConstable()`
  Returns an enum descriptor `EnumDesc` for this instance, if one can be constructed, or an empty `Optional` if one cannot be.
  `final boolean`
  `equals(Object other)`
  Returns true if the specified object is equal to this enum constant.
  `protected final void`
  `finalize()`
  Deprecated, for removal: This API element is subject to removal in a future version.
  Finalization has been deprecated for removal.
  `final Class<NestingKind>`
  `getDeclaringClass()`
  Returns the Class object corresponding to this enum constant's enum type.
  `final int`
  `hashCode()`
  Returns a hash code for this enum constant.
  `final String`
  `name()`
  Returns the name of this enum constant, exactly as declared in its enum declaration.
  `final int`
  `ordinal()`
  Returns the ordinal of this enumeration constant (its position in its enum declaration, where the initial constant is assigned an ordinal of zero).
  `String`
  `toString()`
  Returns the name of this enum constant, as contained in the declaration.
  `static <T extends Enum<T>>
  T`
  `valueOf(Class<T> enumClass, String name)`
  Returns the enum constant of the specified enum class with the specified name.

  ### Methods declared in class Object

  `getClass, notify, notifyAll, wait, wait, wait`
  Modifier and Type
  Method
  Description
  `final Class<?>`
  `getClass()`
  Returns the runtime class of this `Object`.
  `final void`
  `notify()`
  Wakes up a single thread that is waiting on this object's monitor.
  `final void`
  `notifyAll()`
  Wakes up all threads that are waiting on this object's monitor.
  `final void`
  `wait()`
  Causes the current thread to wait until it is awakened, typically by being notified or interrupted.
  `final void`
  `wait(long timeoutMillis)`
  Causes the current thread to wait until it is awakened, typically by being notified or interrupted, or until a certain amount of real time has elapsed.
  `final void`
  `wait(long timeoutMillis, int nanos)`
  Causes the current thread to wait until it is awakened, typically by being notified or interrupted, or until a certain amount of real time has elapsed.

- ## Enum Constant Details

  - ### TOP_LEVEL

    public static final NestingKind TOP_LEVEL
    A top-level class or interface, not contained within another class or interface.

  - ### MEMBER

    public static final NestingKind MEMBER
    A class or interface that is a named member of another class or interface.
    See Java Language Specification:
      8.5 Member Class and Interface Declarations

  - ### LOCAL

    public static final NestingKind LOCAL
    A named class or interface declared within a construct other than a class or interface.
    See Java Language Specification:
      14.3 Local Class and Interface Declarations

  - ### ANONYMOUS

    public static final NestingKind ANONYMOUS
    A class without a name.
    See Java Language Specification:
      15.9.5 Anonymous Class Declarations

- ## Method Details

  - ### values

    public static NestingKind[] values()
    Returns an array containing the constants of this enum class, in the order they are declared.
    Returns:
      an array containing the constants of this enum class, in the order they are declared

  - ### valueOf

    public static NestingKind valueOf(String name)
    Returns the enum constant of this class with the specified name. The string must match exactly an identifier used to declare an enum constant in this class. (Extraneous whitespace characters are not permitted.)
    Parameters:
      `name` - the name of the enum constant to be returned.
    Returns:
      the enum constant with the specified name
    Throws:
      `IllegalArgumentException` - if this enum class has no constant with the specified name
      `NullPointerException` - if the argument is null

  - ### isNested

    public boolean isNested()
    Does this constant correspond to a nested type element? A nested type element is any that is not top-level. More specifically, an inner type element is any nested type element that is not static.
    Returns:
      whether or not the constant is nested
    See Java Language Specification:
      14.3 Local Class and Interface Declarations